searchNodes=[{"type":"module","title":"Pesapal","doc":"Handles integration with Pesapal payment gateway API (v3). This module provides functions to authenticate, register IPN webhooks, initiate payments, and check transaction statuses with the Pesapal API. The flow is as follows: Authenticate with Pesapal using authenticate/2 . Register an IPN webhook using register_ipn/2 . Initiate a payment using initiate_payment/6 . Check the transaction status using check_transaction_status/2 . Handle the IPN notifications sent to your webhook URL. For your IPN webhook, you need to set up a route in your application to handle incoming POST requests from Pesapal. The IPN URL should be publicly accessible and should be able to process the incoming notifications. This can be a simple post endpoint in your application as follows defmodule AppWeb.OrderController do use AppWeb , :controller def create ( conn , params ) do IO . inspect ( params ) # Handle the IPN notification here conn |&gt; Plug.Conn . put_resp_content_type ( &quot;application/json&quot; ) |&gt; Plug.Conn . send_resp ( 200 , Jason . encode! ( %{ message : &quot;Success&quot; } ) ) end end # In your router.ex file, add a route for the IPN webhook defmodule AppWeb.Router do use AppWeb , :router scope &quot;/api&quot; , AppWeb do pipe_through :api post &quot;/webhook&quot; , OrderController , :create end end Configuration You need to set the api_base_url in your application configuration , as well as your consumer key and consumer secret. You can set this in your config file: config :pesapal , api_base_url : &quot;https://cybqa.pesapal.com/pesapalv3/api&quot; , consumer_key : &quot;qkio1BGGYAXTu2JOfm7XSXNruoZsrqEW&quot; , consumer_secret : &quot;osGQ364R49cXKeOYSpaOnT++rHs=&quot; For Production: config :pesapal , api_base_url : &quot;https://www.pesapal.com/pesapalv3/api&quot; , consumer_key : &quot;qkio1BGGYAXTu2JOfm7XSXNruoZsrqEW&quot; , consumer_secret : &quot;osGQ364R49cXKeOYSpaOnT++rHs=&quot;","ref":"Pesapal.html"},{"type":"function","title":"Pesapal.authenticate/0","doc":"Authenticates with Pesapal API and returns an access token. Returns {:ok, %{&quot;token&quot; =&gt; token, &quot;expiryDate&quot; =&gt; expiry_date}} - Success with token details {:error, reason} - Error with reason Examples iex&gt; Pesapal . authenticate ( &quot;your_key&quot; , &quot;your_secret&quot; ) { :ok , %{ &quot;token&quot; =&gt; &quot;abc123&quot; , &quot;expiryDate&quot; =&gt; &quot;2023-01-01T00:00:00Z&quot; } }","ref":"Pesapal.html#authenticate/0"},{"type":"function","title":"Pesapal.check_transaction_status/2","doc":"Checks the status of a transaction. Parameters order_tracking_id - The order tracking ID from initiate_payment/5 token - The authentication token from authenticate/2 Returns {:ok, %{&quot;status&quot; =&gt; status, &quot;payment_method&quot; =&gt; method, ...}} - Success with transaction details {:error, reason} - Error with reason Examples iex&gt; Pesapal . check_transaction_status ( &quot;ord123&quot; , &quot;abc123&quot; ) { :ok , %{ &quot;status&quot; =&gt; &quot;COMPLETED&quot; , &quot;payment_method&quot; =&gt; &quot;MPESA&quot; } } Note The status code represents the payment_status_description . 0 - INVALID 1 - COMPLETED 2 - FAILED 3 - REVERSED","ref":"Pesapal.html#check_transaction_status/2"},{"type":"function","title":"Pesapal.initiate_payment/7","doc":"Initiates a payment transaction with Pesapal. Parameters amount - The payment amount (numeric) email - Customer's email address currency - Currency code (e.g., &quot;KES&quot;, &quot;USD&quot;) ipn_id - IPN ID from register_ipn/2 callback_url - Callback URL where customers will be redirected after successful payment token - The authentication token from authenticate/2 opts - Optional parameters: :description - Payment description (default: &quot;Payment&quot;) :order_id - Custom order ID (default: auto-generated) Returns {:ok, %{&quot;order_tracking_id&quot; =&gt; id, &quot;redirect_url&quot; =&gt; url, ...}} - Success with payment details {:error, reason} - Error with reason Examples iex&gt; Pesapal . initiate_payment ( 1000 , &quot;user@example.com&quot; , &quot;KES&quot; , &quot;ipn123&quot; , &quot;https://example.com/callback&quot; , &quot;abc123&quot; ) { :ok , %{ &quot;order_tracking_id&quot; =&gt; &quot;ord123&quot; , &quot;redirect_url&quot; =&gt; &quot;https://pesapal.com/payment/...&quot; } } iex&gt; Pesapal . initiate_payment ( 1000 , &quot;user@example.com&quot; , &quot;KES&quot; , &quot;ipn123&quot; , &quot;https://example.com/callback&quot; , &quot;abc123&quot; , [ description : &quot;Test Payment&quot; ] ) { :ok , %{ &quot;order_tracking_id&quot; =&gt; &quot;ord123&quot; , &quot;redirect_url&quot; =&gt; &quot;https://pesapal.com/payment/...&quot; } }","ref":"Pesapal.html#initiate_payment/7"},{"type":"function","title":"Pesapal.register_ipn/2","doc":"Registers an Instant Payment Notification (IPN) webhook with Pesapal. Parameters webhook_url - The URL to receive payment notifications token - The authentication token from authenticate/2 Returns {:ok, %{&quot;ipn_id&quot; =&gt; ipn_id, ...}} - Success with IPN details {:error, reason} - Error with reason Examples iex&gt; Pesapal . register_ipn ( &quot;https://example.com/webhook&quot; , &quot;abc123&quot; ) { :ok , %{ &quot;ipn_id&quot; =&gt; &quot;ipn123&quot; , &quot;url&quot; =&gt; &quot;https://example.com/webhook&quot; } }","ref":"Pesapal.html#register_ipn/2"}]